/* Copyright_License {

  XCSoar Glide Computer - http://www.xcsoar.org/
  Copyright (C) 2000-2014 The XCSoar Project
  A detailed list of copyright holders can be found in the file "AUTHORS".

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}
*/

#include "Math/Angle.hpp"

#include <stdio.h>

#define NUM_WIND 9

static inline fixed
wind_to_mag(int n_wind)
{
  if (n_wind)
    return (fixed(n_wind - 1) / 4 + fixed(1)) * 5;

  return fixed(0);
}

static inline Angle
wind_to_dir(int n_wind)
{
  if (n_wind)
    return Angle::Degrees(fixed(90 * ((n_wind - 1) % 4))).AsBearing();

  return Angle::Zero();
}

static inline const char*
wind_name(int n_wind)
{
  static char buffer[80];
  sprintf(buffer,"%d m/s @ %d", (int)wind_to_mag(n_wind),
          (int)wind_to_dir(n_wind).Degrees());
  return buffer;
}
